<?php

namespace Andy\DuplicateAccountCheck\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

class DuplicateAccountCheck extends Entity
{
    public static function getStructure(Structure $structure)
    {
        $structure->table = 'xf_andy_duplicate_account_check';
        $structure->shortName = 'Andy\DuplicateAccountCheck:DuplicateAccountCheck';
        $structure->primaryKey = 'user_id';
        $structure->columns = [
            'user_id' => ['type' => self::UINT, 'default' => 0],
            'ip' => ['type' => self::STR, 'maxLength' => 39, 'default' => ''],
            'location' => ['type' => self::STR, 'maxLength' => 255, 'default' => ''],
            'user_agent' => ['type' => self::STR, 'maxLength' => 255, 'default' => ''],
            'view_date' => ['type' => self::UINT, 'default' => 0]
        ];
        $structure->getters = [];
        $structure->relations = [
            'User' => [
                'entity' => 'XF:User',
                'type' => self::TO_ONE,
                'conditions' => 'user_id',
                'primary' => true
            ]
        ];

        return $structure;
    }  
}