<?php

namespace Andy\DuplicateAccountCheck;

class Listener
{
    public static function appPubRenderPage(
        \XF\Pub\App $app,
        array &$params,
        \XF\Mvc\Reply\AbstractReply $reply,
        \XF\Mvc\Renderer\AbstractRenderer $renderer
    ) 
	{
		// get visitor
		$visitor = \XF::visitor();
		
		// get userId
		$userId = $visitor['user_id'];
        
        // get userState
        $userState = $visitor['user_state'];
        
        // get isBanned
        $isBanned = $visitor['is_banned'];
	
		// check condition
		if ($userId > 0 AND $isBanned == 0)
		{
            // check condition
            if ($userState == 'valid' OR $userState == 'moderated')
            { 
                // get options
                $options = \XF::options();

                // get options from Admin CP -> Options -> Duplicate account check -> Exclude usernames
                $excludeUsernames = $options->duplicateAccountCheckExcludeUsernames;

                // check condition
                if (!in_array($userId, $excludeUsernames))
                {
                    // get userAgent
                    $user_agent = @$_SERVER['HTTP_USER_AGENT'];

                    // limit length of userAgent
                    $user_agent = substr($user_agent, 0, 254);

                    // get ip
                    $ip = \XF::app()->request()->getIp();

                    // limit length of ip
                    $ip = substr($ip, 0, 38);

                    // get location
                    $location = (isset($_SERVER['HTTPS']) ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";

                    // limit length of location
                    $location = substr($location, 0, 254);			

                    // get time
                    $view_date = time();	

                    // make safe for query
                    $user_agent = addslashes($user_agent);				

                    // show n/a if over 250 characters
                    if (strlen($user_agent) > 255)
                    {
                        $user_agent = 'n/a';
                    }

                    // get result
                    $finder = \XF::finder('Andy\DuplicateAccountCheck:DuplicateAccountCheck');
                    $result = $finder
                        ->where('user_id', $userId)
                        ->fetchOne();

                    // check condition
                    if (empty($result->user_id))
                    {
                        // suppress intermittent duplicate entry error
                        try
                        {
                            // save duplicateAccountCheck
                            $duplicateAccountCheck = \XF::em()->create('Andy\DuplicateAccountCheck:DuplicateAccountCheck');
                            $duplicateAccountCheck->user_id = $userId;
                            $duplicateAccountCheck->ip = $ip;
                            $duplicateAccountCheck->location = $location;
                            $duplicateAccountCheck->user_agent = $user_agent;
                            $duplicateAccountCheck->view_date = $view_date;
                            $duplicateAccountCheck->save();
                        }
                        catch (\Exception $e)
                        {
                        }    
                    }	
                }
            }
        }
    }
}