<?php

namespace Andy\DuplicateAccountCheck;

use XF\AddOn\AbstractSetup;
use XF\AddOn\StepRunnerUpgradeTrait;
use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends AbstractSetup
{
	use StepRunnerUpgradeTrait;
	
	public function install(array $stepParams = [])
	{
		$this->schemaManager()->createTable('xf_andy_duplicate_account_check', function(Create $table)
		{
			$table->addColumn('user_id', 'int');
			$table->addColumn('ip', 'varchar', 39);
			$table->addColumn('location', 'varchar', 255);
			$table->addColumn('user_agent', 'varchar', 255);
			$table->addColumn('view_date', 'int');
			$table->addPrimaryKey('user_id');
		});
	}
	
	public function upgrade(array $stepParams = [])
	{	
	}

	public function uninstall(array $stepParams = [])
	{
		$this->schemaManager()->dropTable('xf_andy_duplicate_account_check');		
	}
}